/****************************************************************************************************************************************** 
* ļ:	SWM181_cmp.c
* ˵:	SWM181ƬCMPȽ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾:	V1.0.0		2016130
* ¼:  
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology
*******************************************************************************************************************************************/
#include "SWM181.h"
#include "SWM181_cmp.h"


/****************************************************************************************************************************************** 
* :	CMP_Init()
* ˵:	CMPģȽʼ
*     : uint32_t CMPx		ָҪõıȽЧֵCMP0CMP1CMP2
*			uint32_t inp_ex		ȽIN+ѡ1 ⲿCMPxP    0 ڲVREFοѹ
*			uint32_t hys_en		Ƚʹܣ   1      0 رճ
*			uint32_t int_en		Ƚ仯жʹ		 	
*     : 
* ע: 
******************************************************************************************************************************************/
void CMP_Init(uint32_t CMPx, uint32_t inp_ex, uint32_t hys_en, uint32_t int_en)
{
	switch(CMPx)
	{
	case CMP0:
		SYS->CMPCR &= ~(SYS_CMPCR_CMP0INP_Msk | SYS_CMPCR_CMP0HYS_Msk);
		SYS->CMPCR |= (inp_ex << SYS_CMPCR_CMP0INP_Pos) | (hys_en << SYS_CMPCR_CMP0HYS_Pos);
		CMP_INTClr(CMP0);
		SYS->CMPSR &= ~SYS_CMPSR_CMP0IE_Msk;
		SYS->CMPSR |= (int_en << SYS_CMPSR_CMP0IE_Pos);
		break;
	
	case CMP1:
		SYS->CMPCR &= ~(SYS_CMPCR_CMP1INP_Msk | SYS_CMPCR_CMP1HYS_Msk);
		SYS->CMPCR |= (inp_ex << SYS_CMPCR_CMP1INP_Pos) | (hys_en << SYS_CMPCR_CMP1HYS_Pos);
		CMP_INTClr(CMP1);
		SYS->CMPSR &= ~SYS_CMPSR_CMP1IE_Msk;
		SYS->CMPSR |= (int_en << SYS_CMPSR_CMP1IE_Pos);
		break;
	
	case CMP2:
		SYS->CMPCR &= ~(SYS_CMPCR_CMP2INP_Msk | SYS_CMPCR_CMP2HYS_Msk);
		SYS->CMPCR |= (inp_ex << SYS_CMPCR_CMP2INP_Pos) | (hys_en << SYS_CMPCR_CMP2HYS_Pos);
		CMP_INTClr(CMP2);
		SYS->CMPSR &= ~SYS_CMPSR_CMP2IE_Msk;
		SYS->CMPSR |= (int_en << SYS_CMPSR_CMP2IE_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	CMP_Open()
* ˵:	Ƚ
*     : uint32_t CMPx		ָҪõıȽЧֵCMP0CMP1CMP2
*     : 
* ע: 
******************************************************************************************************************************************/
void CMP_Open(uint32_t CMPx)
{
	switch(CMPx)
	{
	case CMP0:
		SYS->CMPCR |= (0x01 << SYS_CMPCR_CMP0EN_Pos);
		break;
	
	case CMP1:
		SYS->CMPCR |= (0x01 << SYS_CMPCR_CMP1EN_Pos);
		break;
	
	case CMP2:
		SYS->CMPCR |= (0x01 << SYS_CMPCR_CMP2EN_Pos);
		break;
	}		
}

/****************************************************************************************************************************************** 
* :	CMP_Close()
* ˵:	رձȽ
*     : uint32_t CMPx		ָҪõıȽЧֵCMP0CMP1CMP2
*     : 
* ע: 
******************************************************************************************************************************************/
void CMP_Close(uint32_t CMPx)
{
	switch(CMPx)
	{
	case CMP0:
		SYS->CMPCR &= ~(0x01 << SYS_CMPCR_CMP0EN_Pos);
		break;
	
	case CMP1:
		SYS->CMPCR &= ~(0x01 << SYS_CMPCR_CMP1EN_Pos);
		break;
	
	case CMP2:
		SYS->CMPCR &= ~(0x01 << SYS_CMPCR_CMP2EN_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	CMP_Output()
* ˵:	Ƚ
*     : uint32_t CMPx		ָҪõıȽЧֵCMP0CMP1CMP2
*     : uint32_t			0 CMPxNƽCMPxPƽ    1 CMPxNƽCMPxPƽ    0xFF úʱ
* ע: 
******************************************************************************************************************************************/
uint32_t CMP_Output(uint32_t CMPx)
{
	switch(CMPx)
	{
	case CMP0:
		return (SYS->CMPSR & SYS_CMPSR_CMP0OUT_Msk) ? 1 : 0;
	
	case CMP1:
		return (SYS->CMPSR & SYS_CMPSR_CMP1OUT_Msk) ? 1 : 0;
	
	case CMP2:
		return (SYS->CMPSR & SYS_CMPSR_CMP2OUT_Msk) ? 1 : 0;
	}
	
	return 0xFF;
}

/****************************************************************************************************************************************** 
* :	CMP_SetVRef()
* ˵:	ڲοѹ
*     : uint32_t volt		ڲοѹЧֵCMP_VREF_0V30CMP_VREF_0V45... ... CMP_VREF_2V55
*     : 
* ע: 
******************************************************************************************************************************************/
void CMP_SetVRef(uint32_t volt)
{
	SYS->CMPCR &= ~SYS_CMPCR_VREF_Msk;
	SYS->CMPCR |= (volt << SYS_CMPCR_VREF_Pos);
}


/****************************************************************************************************************************************** 
* :	CMP_INTEn()
* ˵:	Ƚ仯жʹ
*     : uint32_t CMPx		ָҪõıȽЧֵCMP0CMP1CMP2
*     : 
* ע: 
******************************************************************************************************************************************/
void CMP_INTEn(uint32_t CMPx)
{
	switch(CMPx)
	{
	case CMP0:
		SYS->CMPSR |= (0x01 << SYS_CMPSR_CMP0IE_Pos);
		break;
	
	case CMP1:
		SYS->CMPSR |= (0x01 << SYS_CMPSR_CMP1IE_Pos);
		break;
	
	case CMP2:
		SYS->CMPSR |= (0x01 << SYS_CMPSR_CMP2IE_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	CMP_INTDis()
* ˵:	Ƚ仯жϽֹ
*     : uint32_t CMPx		ָҪõıȽЧֵCMP0CMP1CMP2
*     : 
* ע: 
******************************************************************************************************************************************/
void CMP_INTDis(uint32_t CMPx)
{
	switch(CMPx)
	{
	case CMP0:
		SYS->CMPSR &= ~(0x01 << SYS_CMPSR_CMP0IE_Pos);
		break;
	
	case CMP1:
		SYS->CMPSR &= ~(0x01 << SYS_CMPSR_CMP1IE_Pos);
		break;
	
	case CMP2:
		SYS->CMPSR &= ~(0x01 << SYS_CMPSR_CMP2IE_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	CMP_INTClr()
* ˵:	Ƚ仯жϱ־
*     : uint32_t CMPx		ָҪõıȽЧֵCMP0CMP1CMP2
*     : 
* ע: 
******************************************************************************************************************************************/
void CMP_INTClr(uint32_t CMPx)
{
	switch(CMPx)
	{
	case CMP0:
		SYS->CMPSR = (SYS->CMPSR & 0xFF) | (0x01 << SYS_CMPSR_CMP0IF_Pos);
		break;
	
	case CMP1:
		SYS->CMPSR = (SYS->CMPSR & 0xFF) | (0x01 << SYS_CMPSR_CMP1IF_Pos);
		break;
	
	case CMP2:
		SYS->CMPSR = (SYS->CMPSR & 0xFF) | (0x01 << SYS_CMPSR_CMP2IF_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	CMP_INTStat()
* ˵:	Ƚ仯ж״̬
*     : uint32_t CMPx		ָҪõıȽЧֵCMP0CMP1CMP2
*     : uint32_t			1 Ƚб仯    0 Ƚޱ仯    0xFF úʱ
* ע: 
******************************************************************************************************************************************/
uint32_t CMP_INTStat(uint32_t CMPx)
{
	switch(CMPx)
	{
	case CMP0:
		return (SYS->CMPSR & SYS_CMPSR_CMP0IF_Msk);
	
	case CMP1:
		return (SYS->CMPSR & SYS_CMPSR_CMP1IF_Msk);
	
	case CMP2:
		return (SYS->CMPSR & SYS_CMPSR_CMP2IF_Msk);
	}
	
	return 0xFF;
}
