#ifndef __SWM181_CORDIC_H__
#define __SWM181_CORDIC_H__

#define CORDIC_PI	3.141592653589793

void CORDIC_Init(CORDIC_TypeDef * CORDICx);


/****************************************************************************************************************************************** 
* :	CORDIC_Sin()
* ˵:	ʹCORDICģsin
*     : uint32_t radian		ҪsinֵĽǶȣԻΪλȡֵΧ0.01~1.56Ҫֵ16384Ϊô˺
*     : 
* ע: Ҫֵ16384Ϊô˺
******************************************************************************************************************************************/
static __INLINE void CORDIC_Sin(uint32_t radian)
{
	CORDIC->INPUT = radian;
	
	CORDIC->CMD = (1 << CORDIC_CMD_START_Pos) | (1 << CORDIC_CMD_SINCOS_Pos);
}

/****************************************************************************************************************************************** 
* :	CORDIC_Sin_IsDone()
* ˵:	CORDICģsinǷ
*     : 
*     : uint32_t		0 sinδ    1 sinɣȡ
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t CORDIC_Sin_IsDone(void)
{
	return (CORDIC->SIN & CORDIC_SIN_DONE_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	CORDIC_Sin_Result()
* ˵:	ȡCORDICģsin
*     : 
*     : uint32_t		sinResult[15:14]ʾ֣Result[13:0]ʾС
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t CORDIC_Sin_Result(void)
{
	return CORDIC->SIN & (CORDIC_SIN_F_Msk | CORDIC_SIN_I_Msk);
}

/****************************************************************************************************************************************** 
* :	CORDIC_Cos()
* ˵:	ʹCORDICģcos
*     : uint32_t radian		ҪcosֵĽǶȣԻΪλȡֵΧ0.01~1.56Ҫֵ16384Ϊô˺
*     : 
* ע: Ҫֵ16384Ϊô˺
******************************************************************************************************************************************/
static __INLINE void CORDIC_Cos(uint32_t radian)
{
	CORDIC->INPUT = radian;
	
	CORDIC->CMD = (1 << CORDIC_CMD_START_Pos) | (1 << CORDIC_CMD_SINCOS_Pos);
}

/****************************************************************************************************************************************** 
* :	CORDIC_Cos_IsDone()
* ˵:	CORDICģcosǷ
*     : 
*     : uint32_t		0 cosδ    1 cosɣȡ
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t CORDIC_Cos_IsDone(void)
{
	return (CORDIC->COS & CORDIC_COS_DONE_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	CORDIC_Cos_Result()
* ˵:	ȡCORDICģcos
*     : 
*     : uint32_t		cosResult[15:14]ʾ֣Result[13:0]ʾС
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t CORDIC_Cos_Result(void)
{
	return CORDIC->COS & (CORDIC_COS_F_Msk | CORDIC_COS_I_Msk);
}

/****************************************************************************************************************************************** 
* :	CORDIC_Arctan()
* ˵:	ʹCORDICģarctan
*     : uint32_t input		ȡֵΧ0.05~10000Ҫ16384Ϊô˺
*     : 
* ע: Ҫֵ16384Ϊô˺
******************************************************************************************************************************************/
static __INLINE void CORDIC_Arctan(uint32_t input)
{
	if((input > 819) && (input <= 8192))
	{
		CORDIC->INPUT = input * 2;
		
		CORDIC->CMD = (1 << CORDIC_CMD_START_Pos) | (0 << CORDIC_CMD_SINCOS_Pos) | (0 << CORDIC_CMD_RANGE_Pos);
	}
	else if((input > 8192) && (input <= 32768))
	{
		CORDIC->INPUT = input;
		
		CORDIC->CMD = (1 << CORDIC_CMD_START_Pos) | (0 << CORDIC_CMD_SINCOS_Pos) | (1 << CORDIC_CMD_RANGE_Pos);
	}
	else if((input > 32768) && (input < 10000*16384))
	{
		DIV_Div(32768*16384, input);
		while(DIV_Div_IsBusy());
		
		CORDIC->INPUT = DIV->QUO;
		
		CORDIC->CMD = (1 << CORDIC_CMD_START_Pos) | (0 << CORDIC_CMD_SINCOS_Pos) | (2 << CORDIC_CMD_RANGE_Pos);
	}
}

/****************************************************************************************************************************************** 
* :	CORDIC_Arctan_IsDone()
* ˵:	CORDICģarctanǷ
*     : 
*     : uint32_t		0 arctanδ    1 arctanɣȡ
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t CORDIC_Arctan_IsDone(void)
{
	return (CORDIC->ARCTAN & CORDIC_ARCTAN_DONE_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	CORDIC_Arctan_Result()
* ˵:	ȡCORDICģarctan
*     : 
*     : uint32_t		arctanΪֵResult[15:14]ʾ֣Result[13:0]ʾС
* ע: 
******************************************************************************************************************************************/
static __INLINE uint32_t CORDIC_Arctan_Result(void)
{
	return CORDIC->ARCTAN & (CORDIC_ARCTAN_F_Msk | CORDIC_ARCTAN_I_Msk);
}

#endif //__SWM181_CORDIC_H__
