/****************************************************************************************************************************************** 
* ļ:	SWM181_flash.c
* ˵:	ʹоƬIAPܽƬFlashģEEPROMݣ󲻶ʧ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾: V1.0.0		2016130
* ¼: 
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology  
*******************************************************************************************************************************************/
#include "SWM181.h"
#include "SWM181_flash.h"

typedef void (*IAPFunc)(uint32_t faddr, uint32_t raddr, uint32_t cnt, uint32_t cmd);
IAPFunc IAPfunc = (IAPFunc)0x1000601;

/****************************************************************************************************************************************** 
* :	FLASH_Erase()
* ˵:	FLASHÿ4Kֽ
*     : uint32_t addr		Ҫĵַ4K룬addr%4096 == 0
*     : 
* ע: 
******************************************************************************************************************************************/
void FLASH_Erase(uint32_t addr)
{
	uint32_t i;
	
	__disable_irq();
	
	IAPfunc(addr, 0, 0, 0x51);
	
	addr = addr / 4096 * 4096;
	for(i = 0; i < 4096; i += 128)
		CACHE_Invalid(addr + i);
	
	__enable_irq();
}

/****************************************************************************************************************************************** 
* :	FLASH_Write()
* ˵:	FLASHд
*     : uint32_t addr		Ҫд뵽Flashеĵֶַ
*			uint32_t buff[]		ҪдFlashе
*			uint32_t cnt		ҪдݵĸΪλȡֵ64
*     : 
* ע: Ҫдݱȫͬһҳڣaddr/256 == (addr+(cnt-1)*4)/256
******************************************************************************************************************************************/
void FLASH_Write(uint32_t addr, uint32_t buff[], uint32_t cnt)
{	
	uint32_t i;
	
	__disable_irq();
	
	FLASH->CR = (1 << FLASH_CR_FFCLR_Pos);			//Clear FIFO
	FLASH->CR = 0;
	
	IAPfunc(addr, (uint32_t)buff, cnt*4, 0x52);
	
	for(i = 0; i < cnt*4; i += 128)
		CACHE_Invalid(addr + i);
	
	__enable_irq();
}

/****************************************************************************************************************************************** 
* :	FLASH_Read()
* ˵:	FLASHݶȡ
*     : uint32_t addr		ҪȡFlashеĵֶַ
*			uint32_t buff[]		ȡݴbuffָڴ
*			uint32_t cnt		ҪȡݵĸΪλ
*     : 
* ע: 
******************************************************************************************************************************************/
void FLASH_Read(uint32_t addr, uint32_t buff[], uint32_t cnt)
{	
	uint32_t i;
	
	if(SYS->CACHECR & SYS_CACHECR_BYPASS_Msk)
	{
		while(FLASH->STAT & FLASH_STAT_BUSY_Msk);
		
		FLASH->CR = (1 << FLASH_CR_FFCLR_Pos);			//Clear FIFO
		
		FLASH->CR = (FLASH_CMD_READ_DATA << FLASH_CR_CMD_Pos) |
					(0 << FLASH_CR_LEN_Pos);			//
		FLASH->ADDR = addr;
		FLASH->START = 1;
		
		for(i = 0; i < cnt; i++)
		{
			while(FLASH->STAT & FLASH_STAT_FE_Msk);		//FIFO Empty
			
			buff[i] = FLASH->DATA;
		}
		
		FLASH->START = 0;
		
		FLASH->CR = (1 << FLASH_CR_FFCLR_Pos);			//Clear FIFO
		FLASH->CR = 0;
	}
	else
	{
		for(i = 0; i < cnt; i++) buff[i] = *((volatile unsigned int *)(addr + i*4));
	}
}



__attribute__((section("PlaceInRAM")))
void AppToIsp(void)
{
	__disable_irq();       //һҪ, ֹжϴDMAĿ	
	*(volatile unsigned int *)0x40000900 = 0x00; //4k mask = 0,лIsp(rom codeѾλ1)
/********************************** Set Cache And Sram Switch *******************************/ 
//	DRAM_SIZE = 0x01; //ֹcachesramΪ16/16	//֮ȷ	
/********************************** Copy Code From Flash To Sram *******************************/	
	DMA->EN = 0x01;			//ÿͨԼĿؿƣܿؿһֱ				
	DMA->CH[DMA_CHR_FLASH].CR &= ~(0x01<<DMA_CR_REN_Pos);		//ǰȹرոͨ	
	DMA->CH[DMA_CHR_FLASH].SRC = 0x400;  //FLASH_ADDR
	DMA->CH[DMA_CHR_FLASH].DST = 0x00;   //SRAM_ADDR	
	DMA->CH[DMA_CHR_FLASH].CR &= ~DMA_CR_LEN_Msk;				
	DMA->CH[DMA_CHR_FLASH].CR |= ((0xC00-1)<<DMA_CR_LEN_Pos);  //copy 3K from Isp to App
	DMA->CH[DMA_CHR_FLASH].CR |= (0x01<<DMA_CR_REN_Pos);	
	while((DMA->CH[DMA_CHR_FLASH].CR&DMA_CR_REN_Msk)==0x01);		
	while(FLASH->STAT&(0x01<<16));                 //ȴFlashCtrlڿ״̬
	*(volatile unsigned int *)0x40000900 = 0x01; //4k mask = 1,лApp(rom codeѾλ1)		
//	__enable_irq();	//ִλԲʹж
/********************************** System Reset(Address(0x00), Sram Code area) ****************/		
	SCB->AIRCR = ((0x5FA<<SCB_AIRCR_VECTKEY_Pos)|SCB_AIRCR_SYSRESETREQ_Msk); //ϵͳλ
	__DSB();                                    /* Ensure completion of memory access */              
	while(1);		
}
