/****************************************************************************************************************************************** 
* ļ:	SWM181_uart.c
* ˵:	SWM181ƬUARTڹ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע: ûбдLINصĺ
* 汾:	V1.0.0		2016130
* ¼: 
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology 
*******************************************************************************************************************************************/
#include "SWM181.h"
#include "SWM181_uart.h"


/****************************************************************************************************************************************** 
* :	UART_Init()
* ˵:	UARTڳʼ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*			UART_InitStructure * initStruct    UART趨ֵĽṹ
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Init(UART_TypeDef * UARTx, UART_InitStructure * initStruct)
{	
	switch((uint32_t)UARTx)
	{
	case ((uint32_t)UART0):
		SYS->CLKEN |= (0x01 << SYS_CLKEN_UART0_Pos);
		break;
	
	case ((uint32_t)UART1):
		SYS->CLKEN |= (0x01 << SYS_CLKEN_UART1_Pos);
		break;
	
	case ((uint32_t)UART2):
		SYS->CLKEN |= (0x01 << SYS_CLKEN_UART2_Pos);
		break;
	
	case ((uint32_t)UART3):
		SYS->CLKEN |= (0x01 << SYS_CLKEN_UART3_Pos);
		break;
	}
	
	UART_Close(UARTx);	//һЩؼĴֻڴڹرʱ
	
	UARTx->CTRL |= (0x01 << UART_CTRL_BAUDEN_Pos);
	UARTx->BAUD &= ~UART_BAUD_BAUD_Msk;
	UARTx->BAUD |= ((SystemCoreClock/16/initStruct->Baudrate - 1) << UART_BAUD_BAUD_Pos);
	
	UARTx->CTRL &= ~(UART_CTRL_DATA9b_Msk | UART_CTRL_PARITY_Msk | UART_CTRL_STOP2b_Msk);
	UARTx->CTRL |= (initStruct->DataBits << UART_CTRL_DATA9b_Pos) |
				   (initStruct->Parity   << UART_CTRL_PARITY_Pos) |
				   (initStruct->StopBits << UART_CTRL_STOP2b_Pos);
	
	UARTx->FIFO &= ~(UART_FIFO_RXTHR_Msk | UART_FIFO_TXTHR_Msk);
	UARTx->FIFO |= (initStruct->RXThreshold << UART_FIFO_RXTHR_Pos) | 
				   (initStruct->TXThreshold << UART_FIFO_TXTHR_Pos);
	
	UARTx->CTRL &= ~UART_CTRL_TOTIME_Msk;
	UARTx->CTRL |= (initStruct->TimeoutTime << UART_CTRL_TOTIME_Pos);
	
	UARTx->CTRL &= ~(UART_CTRL_RXIE_Msk | UART_CTRL_TXIE_Msk | UART_CTRL_TOIE_Msk);
	UARTx->CTRL |= (initStruct->RXThresholdIEn << UART_CTRL_RXIE_Pos) |
				   (initStruct->TXThresholdIEn << UART_CTRL_TXIE_Pos) |
				   (initStruct->TimeoutIEn << UART_CTRL_TOIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_Open()
* ˵:	UARTڴ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Open(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_Close()
* ˵:	UARTڹر
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Close(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_WriteByte()
* ˵:	һֽ
*     : UART_TypeDef * UARTx	ָҪõUARTڣȡֵUART0UART1UART2UART3
*			uint8_t data			Ҫ͵ֽ			
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_WriteByte(UART_TypeDef * UARTx, uint8_t data)
{
	UARTx->DATA = data;
}

/****************************************************************************************************************************************** 
* :	UART_ReadByte()
* ˵:	ȡһֽݣָǷValid
*     : UART_TypeDef * UARTx	ָҪõUARTڣȡֵUART0UART1UART2UART3
*			uint32_t * data			յ
*     : uint32_t				0 ޴    UART_ERR_PARITY żУ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_ReadByte(UART_TypeDef * UARTx, uint32_t * data)
{
	uint32_t reg = UARTx->DATA;
	
	*data = (reg & UART_DATA_DATA_Msk);
	
	if(reg & UART_DATA_PAERR_Msk) return UART_ERR_PARITY;
	
	return 0;
}

/****************************************************************************************************************************************** 
* :	UART_IsTXBusy()
* ˵:	UARTǷڷ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 UARTڷ    0 ѷ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsTXBusy(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_TXIDLE_Msk) ? 0 : 1;
}

/****************************************************************************************************************************************** 
* :	UART_IsRXFIFOEmpty()
* ˵:	FIFOǷΪգ˵ݿԶȡ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 FIFO    0 FIFOǿ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsRXFIFOEmpty(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_RXNE_Msk) ? 0 : 1;
}

/****************************************************************************************************************************************** 
* :	UART_IsTXFIFOFull()
* ˵:	FIFOǷΪԼд
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 FIFO    0 FIFO
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsTXFIFOFull(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_TXFF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_SetBaudrate()
* ˵:	ò
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*			uint32_t baudrate		ҪõĲ
*     : 
* ע: ҪڴڹʱĲʣʹô˺ǰȵUART_Close()رմ
******************************************************************************************************************************************/
void UART_SetBaudrate(UART_TypeDef * UARTx, uint32_t baudrate)
{
	UARTx->BAUD &= ~UART_BAUD_BAUD_Msk;
	UARTx->BAUD |= ((SystemCoreClock/16/baudrate - 1) << UART_BAUD_BAUD_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_GetBaudrate()
* ˵:	ѯ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				ǰ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_GetBaudrate(UART_TypeDef * UARTx)
{
	return SystemCoreClock/16/(((UARTx->BAUD & UART_BAUD_BAUD_Msk) >> UART_BAUD_BAUD_Pos) + 1);
}

/****************************************************************************************************************************************** 
* :	UART_CTSConfig()
* ˵:	UART CTS
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*			uint32_t enable			1 ʹCTS    0 ֹCTS
*			uint32_t polarity		0 CTSΪͱʾԷ    1 CTSΪ߱ʾԷ
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_CTSConfig(UART_TypeDef * UARTx, uint32_t enable, uint32_t polarity)
{
	UARTx->CTSCR &= ~(UART_CTSCR_EN_Msk | UART_CTSCR_POL_Msk);
	UARTx->CTSCR |= (enable   << UART_CTSCR_EN_Pos) |
					(polarity << UART_CTSCR_POL_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_CTSLineState()
* ˵:	UART CTSߵǰ״̬
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				0 CTSߵǰΪ͵ƽ    1 CTSߵǰΪߵƽ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_CTSLineState(UART_TypeDef * UARTx)
{
	return (UARTx->CTSCR & UART_CTSCR_STAT_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_RTSConfig()
* ˵:	UART RTS
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*			uint32_t enable			1 ʹRTS    0 ֹRTS
*			uint32_t polarity		0 RTSͱʾԽ    1 RTS߱ʾԽ
*			uint32_t threshold		RTSصĴֵȡֵUART_RTS_1BYTEUART_RTS_2BYTEUART_RTS_4BYTEUART_RTS_6BYTE
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_RTSConfig(UART_TypeDef * UARTx, uint32_t enable, uint32_t polarity, uint32_t threshold)
{
	UARTx->RTSCR &= ~(UART_RTSCR_EN_Msk | UART_RTSCR_POL_Msk | UART_RTSCR_THR_Msk);
	UARTx->RTSCR |= (enable    << UART_RTSCR_EN_Pos)  |
					(polarity  << UART_RTSCR_POL_Pos) |
					(threshold << UART_RTSCR_THR_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_RTSLineState()
* ˵:	UART RTSߵǰ״̬
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				0 RTSߵǰΪ͵ƽ    1 RTSߵǰΪߵƽ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_RTSLineState(UART_TypeDef * UARTx)
{
	return (UARTx->RTSCR & UART_RTSCR_STAT_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_LINConfig()
* ˵:	UART LIN
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*			uint32_t detectedIEn	⵽Breakжʹ
*			uint32_t generatedIEn	Breakжʹ
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_LINConfig(UART_TypeDef * UARTx, uint32_t detectedIEn, uint32_t generatedIEn)
{
	UARTx->LINCR &= ~(UART_LINCR_BRKDETIE_Msk | UART_LINCR_GENBRKIE_Msk);
	UARTx->LINCR |= (detectedIEn  << UART_LINCR_BRKDETIE_Pos) |
					(generatedIEn << UART_LINCR_GENBRKIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_LINGenerate()
* ˵:	UART LIN/Break
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_LINGenerate(UART_TypeDef * UARTx)
{
	UARTx->LINCR |= (1 << UART_LINCR_GENBRK_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_LINIsDetected()
* ˵:	UART LINǷ⵽Break
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 ⵽LIN Break    0 δ⵽LIN Break
* ע: 
******************************************************************************************************************************************/
uint32_t UART_LINIsDetected(UART_TypeDef * UARTx)
{
	return (UARTx->LINCR & UART_LINCR_BRKDETIF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_LINIsGenerated()
* ˵:	UART LIN BreakǷ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 LIN Break     0 LIN Breakδ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_LINIsGenerated(UART_TypeDef * UARTx)
{
	return (UARTx->LINCR & UART_LINCR_GENBRKIF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_ABRStart()
* ˵:	UART Զʼ⿪ʼ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*			uint32_t detectChar		Զ⡢㲨ʵļַ
*									8λʱȡֵ0xFF0xFE0xF80x80ֱʾͷ뷢0xFF0xFE0xF80x80
*									9λʱȡֵ0x1FF0x1FE0x1F80x180ֱʾͷ뷢0x1FF0x1FE0x1F80x180
*     : 
* ע: ԶʼʱܿżУ
******************************************************************************************************************************************/
void UART_ABRStart(UART_TypeDef * UARTx, uint32_t detectChar)
{
	uint32_t bits;
	
	if((detectChar == 0xFF) || (detectChar == 0x1FF))      bits = 0;
	else if((detectChar == 0xFE) || (detectChar == 0x1FE)) bits = 1;
	else if((detectChar == 0xF8) || (detectChar == 0x1F8)) bits = 2;
	else if((detectChar == 0x80) || (detectChar == 0x180)) bits = 3;
	else while(1);
	
	UARTx->BAUD &= ~(UART_BAUD_ABREN_Msk | UART_BAUD_ABRBIT_Msk);
	UARTx->BAUD |= (1    << UART_BAUD_ABREN_Pos) |
				   (bits << UART_BAUD_ABRBIT_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_ABRIsDone()
* ˵:	UART ԶǷ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				0 δ    UART_ABR_RES_OK ɣҳɹ    UART_ABR_RES_ERR ɣʧܡ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_ABRIsDone(UART_TypeDef * UARTx)
{
	if(UARTx->BAUD & UART_BAUD_ABREN_Msk)
	{
		return 0;
	}
	else if(UARTx->BAUD & UART_BAUD_ABRERR_Msk)
	{
		return UART_ABR_RES_ERR;
	}
	else
	{
		return UART_ABR_RES_OK;
	}
}

/****************************************************************************************************************************************** 
* :	UART_INTRXThresholdEn()
* ˵:	RX FIFOݸ >= RXThresholdʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTRXThresholdEn(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_RXIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTRXThresholdDis()
* ˵:	RX FIFOݸ >= RXThresholdʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTRXThresholdDis(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_RXIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTRXThresholdStat()
* ˵:	ǷRX FIFOݸ >= RXThreshold
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 RX FIFOݸ >= RXThreshold		0 RX FIFOݸ < RXThreshold
* ע: RXIF = RXTHRF & RXIE
******************************************************************************************************************************************/
uint32_t UART_INTRXThresholdStat(UART_TypeDef * UARTx)
{
	return (UARTx->BAUD & UART_BAUD_RXIF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_INTTXThresholdEn()
* ˵:	TX FIFOݸ <= TXThresholdʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTXThresholdEn(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_TXIE_Pos);	
}

/****************************************************************************************************************************************** 
* :	UART_INTTXThresholdDis()
* ˵:	TX FIFOݸ <= TXThresholdʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTXThresholdDis(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_TXIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTTXThresholdStat()
* ˵:	ǷTX FIFOݸ <= TXThreshold
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 TX FIFOݸ <= TXThreshold		0 TX FIFOݸ > TXThreshold
* ע: TXIF = TXTHRF & TXIE
******************************************************************************************************************************************/
uint32_t UART_INTTXThresholdStat(UART_TypeDef * UARTx)
{
	return (UARTx->BAUD & UART_BAUD_TXIF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_INTTimeoutEn()
* ˵:	շʱʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTimeoutEn(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_TOIE_Pos);	
}

/****************************************************************************************************************************************** 
* :	UART_INTTimeoutDis()
* ˵:	շʱʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTimeoutDis(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_TOIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTTimeoutStat()
* ˵:	Ƿ˽ճʱ TimeoutTime/(Baudrate/10) ûRXϽյʱж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 ˽ճʱ		0 δճʱ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_INTTimeoutStat(UART_TypeDef * UARTx)
{
	return (UARTx->BAUD & UART_BAUD_TOIF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_INTTXDoneEn()
* ˵:	FIFOҷλĴжʹ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTXDoneEn(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_TXDOIE_Pos);	
}

/****************************************************************************************************************************************** 
* :	UART_INTTXDoneDis()
* ˵:	FIFOҷλĴжϽֹ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTXDoneDis(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_TXDOIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTTXDoneStat()
* ˵:	FIFOҷλĴж״̬
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 FIFOҷλĴ		0 FIFOλĴδ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_INTTXDoneStat(UART_TypeDef * UARTx)
{
	return (UARTx->BAUD & UART_BAUD_TXDOIF_Msk) ? 1 : 0;
}
