/****************************************************************************************************************************************** 
* ļ:	SWM190_pwm.c
* ˵:	SWM190ƬPWM
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾:	V1.0.0		2016130
* ¼: 
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology 
*******************************************************************************************************************************************/
#include "SWM190.h"
#include "SWM190_pwm.h"


PWM_TypeDef * PWMX[8] = {PWM0, PWM0, PWM1, PWM1, PWM2, PWM2, PWM3, PWM3};


/****************************************************************************************************************************************** 
* :	PWM_Init()
* ˵:	PWMʼ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*			PWM_InitStructure * initStruct	PWM趨ֵĽṹ
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_Init(uint32_t pwmx, PWM_InitStructure * initStruct)
{
	PWM_TypeDef * PWMx = PWMX[pwmx];
	
	SYS->CLKEN0 |= (0x01 << SYS_CLKEN0_PWM_Pos);
	
	PWMG->CLKDIV = initStruct->clkdiv;
	
	PWM_Stop(pwmx);		//һЩؼĴֻPWMֹͣʱ
	
	PWMx->MODE = initStruct->PWMnXN ? 5 : 0;
	
	if((pwmx%2) == 0)
	{
		PWMx->PERA = initStruct->cycle;
		PWMx->HIGHA = initStruct->hduty << 1;
		PWMx->DZA = initStruct->deadzone;
		
		if(initStruct->initLevel) PWMx->OUTCR |=  (1 << PWM_OUTCR_INIA_Pos);
		else                      PWMx->OUTCR &= ~(1 << PWM_OUTCR_INIA_Pos);
		
		PWMG->IM = 0x00000000;
		PWMG->HCIM = 0x000000;
		switch((uint32_t)PWMx)
		{
		case((uint32_t)PWM0):
			PWMG->NCIRS = (1 << PWMG_NCIRS_PWM0A_Pos);
			PWMG->HEIRS = (1 << PWMG_HEIRS_PWM0A_Pos);
			if(initStruct->NCycleIE) PWMG->IE |=  (1 << PWMG_IE_NC0A_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_NC0A_Pos);
			if(initStruct->HEndIE)   PWMG->IE |=  (1 << PWMG_IE_HE0A_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_HE0A_Pos);
			if(initStruct->HCycleIE) PWMG->HCIE |=  (1 << PWMG_HCIE_PWM0A_Pos);
			else                     PWMG->HCIE &= ~(1 << PWMG_HCIE_PWM0A_Pos);
			if(initStruct->HEndIE | initStruct->NCycleIE | initStruct->HCycleIE) NVIC_EnableIRQ(PWM0_IRQn);
			break;

		case((uint32_t)PWM1):
			PWMG->NCIRS = (1 << PWMG_NCIRS_PWM1A_Pos);
			PWMG->HEIRS = (1 << PWMG_HEIRS_PWM1A_Pos);
			if(initStruct->NCycleIE) PWMG->IE |=  (1 << PWMG_IE_NC1A_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_NC1A_Pos);
			if(initStruct->HEndIE)   PWMG->IE |=  (1 << PWMG_IE_HE1A_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_HE1A_Pos);
			if(initStruct->HCycleIE) PWMG->HCIE |=  (1 << PWMG_HCIE_PWM1A_Pos);
			else                     PWMG->HCIE &= ~(1 << PWMG_HCIE_PWM1A_Pos);
			if(initStruct->HEndIE | initStruct->NCycleIE | initStruct->HCycleIE) NVIC_EnableIRQ(PWM1_GPIOB6_IRQn);
			break;

		case((uint32_t)PWM2):
			PWMG->NCIRS = (1 << PWMG_NCIRS_PWM2A_Pos);
			PWMG->HEIRS = (1 << PWMG_HEIRS_PWM2A_Pos);
			if(initStruct->NCycleIE) PWMG->IE |=  (1 << PWMG_IE_NC2A_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_NC2A_Pos);
			if(initStruct->HEndIE)   PWMG->IE |=  (1 << PWMG_IE_HE2A_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_HE2A_Pos);
			if(initStruct->HCycleIE) PWMG->HCIE |=  (1 << PWMG_HCIE_PWM2A_Pos);
			else                     PWMG->HCIE &= ~(1 << PWMG_HCIE_PWM2A_Pos);
			if(initStruct->HEndIE | initStruct->NCycleIE | initStruct->HCycleIE) NVIC_EnableIRQ(PWM2_FLASH_IRQn);
			break;
		
		case((uint32_t)PWM3):
			PWMG->NCIRS = (1 << PWMG_NCIRS_PWM3A_Pos);
			PWMG->HEIRS = (1 << PWMG_HEIRS_PWM3A_Pos);
			if(initStruct->NCycleIE) PWMG->IE |=  (1 << PWMG_IE_NC3A_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_NC3A_Pos);
			if(initStruct->HEndIE)   PWMG->IE |=  (1 << PWMG_IE_HE3A_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_HE3A_Pos);
			if(initStruct->HCycleIE) PWMG->HCIE |=  (1 << PWMG_HCIE_PWM3A_Pos);
			else                     PWMG->HCIE &= ~(1 << PWMG_HCIE_PWM3A_Pos);
			if(initStruct->HEndIE | initStruct->NCycleIE | initStruct->HCycleIE) NVIC_EnableIRQ(PWM3_CACHE_IRQn);
			break;
		}
	}
	else
	{
		PWMx->PERB = initStruct->cycle;
		PWMx->HIGHB = initStruct->hduty << 1;
		PWMx->DZB = initStruct->deadzone;
		
		if(initStruct->initLevel) PWMx->OUTCR |=  (1 << PWM_OUTCR_INIB_Pos);
		else                      PWMx->OUTCR &= ~(1 << PWM_OUTCR_INIB_Pos);
		
		PWMG->IM = 0x00000000;
		PWMG->HCIM = 0x000000;
		switch((uint32_t)PWMx)
		{
		case((uint32_t)PWM0):
			PWMG->NCIRS = (1 << PWMG_NCIRS_PWM0B_Pos);
			PWMG->HEIRS = (1 << PWMG_HEIRS_PWM0B_Pos);
			if(initStruct->NCycleIE) PWMG->IE |=  (1 << PWMG_IE_NC0B_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_NC0B_Pos);
			if(initStruct->HEndIE)   PWMG->IE |=  (1 << PWMG_IE_HE0B_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_HE0B_Pos);
			if(initStruct->HCycleIE) PWMG->HCIE |=  (1 << PWMG_HCIE_PWM0B_Pos);
			else                     PWMG->HCIE &= ~(1 << PWMG_HCIE_PWM0B_Pos);
			if(initStruct->HEndIE | initStruct->NCycleIE | initStruct->HCycleIE) NVIC_EnableIRQ(PWM0_IRQn);
			break;

		case((uint32_t)PWM1):
			PWMG->NCIRS = (1 << PWMG_NCIRS_PWM1B_Pos);
			PWMG->HEIRS = (1 << PWMG_HEIRS_PWM1B_Pos);
			if(initStruct->NCycleIE) PWMG->IE |=  (1 << PWMG_IE_NC1B_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_NC1B_Pos);
			if(initStruct->HEndIE)   PWMG->IE |=  (1 << PWMG_IE_HE1B_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_HE1B_Pos);
			if(initStruct->HCycleIE) PWMG->HCIE |=  (1 << PWMG_HCIE_PWM1B_Pos);
			else                     PWMG->HCIE &= ~(1 << PWMG_HCIE_PWM1B_Pos);
			if(initStruct->HEndIE | initStruct->NCycleIE | initStruct->HCycleIE) NVIC_EnableIRQ(PWM1_GPIOB6_IRQn);
			break;

		case((uint32_t)PWM2):
			PWMG->NCIRS = (1 << PWMG_NCIRS_PWM2B_Pos);
			PWMG->HEIRS = (1 << PWMG_HEIRS_PWM2B_Pos);
			if(initStruct->NCycleIE) PWMG->IE |=  (1 << PWMG_IE_NC2B_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_NC2B_Pos);
			if(initStruct->HEndIE)   PWMG->IE |=  (1 << PWMG_IE_HE2B_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_HE2B_Pos);
			if(initStruct->HCycleIE) PWMG->HCIE |=  (1 << PWMG_HCIE_PWM2B_Pos);
			else                     PWMG->HCIE &= ~(1 << PWMG_HCIE_PWM2B_Pos);
			if(initStruct->HEndIE | initStruct->NCycleIE | initStruct->HCycleIE) NVIC_EnableIRQ(PWM2_FLASH_IRQn);
			break;
		
		case((uint32_t)PWM3):
			PWMG->NCIRS = (1 << PWMG_NCIRS_PWM3B_Pos);
			PWMG->HEIRS = (1 << PWMG_HEIRS_PWM3B_Pos);
			if(initStruct->NCycleIE) PWMG->IE |=  (1 << PWMG_IE_NC3B_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_NC3B_Pos);
			if(initStruct->HEndIE)   PWMG->IE |=  (1 << PWMG_IE_HE3B_Pos);
			else                     PWMG->IE &= ~(1 << PWMG_IE_HE3B_Pos);
			if(initStruct->HCycleIE) PWMG->HCIE |=  (1 << PWMG_HCIE_PWM3B_Pos);
			else                     PWMG->HCIE &= ~(1 << PWMG_HCIE_PWM3B_Pos);
			if(initStruct->HEndIE | initStruct->NCycleIE | initStruct->HCycleIE) NVIC_EnableIRQ(PWM3_CACHE_IRQn);
			break;
		}
	}
}

/****************************************************************************************************************************************** 
* :	PWM_Start()
* ˵:	PWMʼPWM
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_Start(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->CHEN |= (1 << PWMG_CHEN_PWM0A_Pos);
		else              PWMG->CHEN |= (1 << PWMG_CHEN_PWM0B_Pos);
		break;

	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->CHEN |= (1 << PWMG_CHEN_PWM1A_Pos);
		else              PWMG->CHEN |= (1 << PWMG_CHEN_PWM1B_Pos);
		break;

	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->CHEN |= (1 << PWMG_CHEN_PWM2A_Pos);
		else              PWMG->CHEN |= (1 << PWMG_CHEN_PWM2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->CHEN |= (1 << PWMG_CHEN_PWM3A_Pos);
		else              PWMG->CHEN |= (1 << PWMG_CHEN_PWM3B_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	PWM_Stop()
* ˵:	رPWMֹͣPWM
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_Stop(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->CHEN &= ~(1 << PWMG_CHEN_PWM0A_Pos);
		else              PWMG->CHEN &= ~(1 << PWMG_CHEN_PWM0B_Pos);
		break;

	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->CHEN &= ~(1 << PWMG_CHEN_PWM1A_Pos);
		else              PWMG->CHEN &= ~(1 << PWMG_CHEN_PWM1B_Pos);
		break;

	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->CHEN &= ~(1 << PWMG_CHEN_PWM2A_Pos);
		else              PWMG->CHEN &= ~(1 << PWMG_CHEN_PWM2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->CHEN &= ~(1 << PWMG_CHEN_PWM3A_Pos);
		else              PWMG->CHEN &= ~(1 << PWMG_CHEN_PWM3B_Pos);
		break;
	} 
}

/****************************************************************************************************************************************** 
* :	PWM_SetCycle()
* ˵:	
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*			uint32_t cycle			Ҫ趨ֵ,28λ
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_SetCycle(uint32_t pwmx, uint32_t cycle)
{
	PWM_TypeDef * PWMx = PWMX[pwmx];
	
	if((pwmx%2) == 0) PWMx->PERA = cycle;
	else              PWMx->PERB = cycle;
}

/****************************************************************************************************************************************** 
* :	PWM_GetCycle()
* ˵:	ȡ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : uint32_t				ȡֵ
* ע: 
******************************************************************************************************************************************/
uint32_t PWM_GetCycle(uint32_t pwmx)
{
	PWM_TypeDef * PWMx = PWMX[pwmx];
	
	if((pwmx%2) == 0) return PWMx->PERA;
	else              return PWMx->PERB;
}

/****************************************************************************************************************************************** 
* :	PWM_SetHDuty()
* ˵:	øߵƽʱ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*			uint32_t hduty			Ҫ趨ĸߵƽʱ,28λ
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_SetHDuty(uint32_t pwmx, uint32_t hduty)
{
	PWM_TypeDef * PWMx = PWMX[pwmx];
	
	if((pwmx%2) == 0) PWMx->HIGHA = hduty << 1;
	else              PWMx->HIGHB = hduty << 1;
}

/****************************************************************************************************************************************** 
* :	PWM_GetHDuty()
* ˵: ȡߵƽʱ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : uint32_t				ȡĸߵƽʱ
* ע: 
******************************************************************************************************************************************/
uint32_t PWM_GetHDuty(uint32_t pwmx)
{
	PWM_TypeDef * PWMx = PWMX[pwmx];
		
	if((pwmx%2) == 0) return PWMx->HIGHA >> 1;
	else              return PWMx->HIGHB >> 1;
}

/****************************************************************************************************************************************** 
* :	PWM_SetDeadzone()
* ˵:	ʱ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*			uint16_t deadzone		Ҫ趨ʱȡֵΧ0--1023
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_SetDeadzone(uint32_t pwmx, uint16_t deadzone)
{
	PWM_TypeDef * PWMx = PWMX[pwmx];
	
	if((pwmx%2) == 0) PWMx->DZA = deadzone;
	else              PWMx->DZB = deadzone;
}

/****************************************************************************************************************************************** 
* :	PWM_GetDeadzone()
* ˵: ȡʱ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : uint16_t					ȡʱ
* ע: 
******************************************************************************************************************************************/
uint16_t  PWM_GetDeadzone(uint32_t pwmx)
{
	PWM_TypeDef * PWMx = PWMX[pwmx];
		
	if((pwmx%2) == 0) return PWMx->DZA;
	else              return PWMx->DZB;
}


/****************************************************************************************************************************************** 
* :	PWM_IntNCycleEn()
* ˵: ڿʼжʹ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntNCycleEn(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->IE |= (0x01 << PWMG_IE_NC0A_Pos);
		else			  PWMG->IE |= (0x01 << PWMG_IE_NC0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->IE |= (0x01 << PWMG_IE_NC1A_Pos);
		else			  PWMG->IE |= (0x01 << PWMG_IE_NC1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->IE |= (0x01 << PWMG_IE_NC2A_Pos);
		else			  PWMG->IE |= (0x01 << PWMG_IE_NC2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->IE |= (0x01 << PWMG_IE_NC3A_Pos);
		else			  PWMG->IE |= (0x01 << PWMG_IE_NC3B_Pos);
		break;
	} 
}

/****************************************************************************************************************************************** 
* :	PWM_IntNCycleDis()
* ˵: ڿʼжϽ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntNCycleDis(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->IE &= ~(0x01 << PWMG_IE_NC0A_Pos);
		else			  PWMG->IE &= ~(0x01 << PWMG_IE_NC0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->IE &= ~(0x01 << PWMG_IE_NC1A_Pos);
		else			  PWMG->IE &= ~(0x01 << PWMG_IE_NC1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->IE &= ~(0x01 << PWMG_IE_NC2A_Pos);
		else			  PWMG->IE &= ~(0x01 << PWMG_IE_NC2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->IE &= ~(0x01 << PWMG_IE_NC3A_Pos);
		else			  PWMG->IE &= ~(0x01 << PWMG_IE_NC3B_Pos);
		break;
	} 
}

/****************************************************************************************************************************************** 
* :	PWM_IntNCycleClr()
* ˵: ڿʼжϱ־
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntNCycleClr(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->NCIRS = (0x01 << PWMG_NCIRS_PWM0A_Pos);
		else			  PWMG->NCIRS = (0x01 << PWMG_NCIRS_PWM0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->NCIRS = (0x01 << PWMG_NCIRS_PWM1A_Pos);
		else			  PWMG->NCIRS = (0x01 << PWMG_NCIRS_PWM1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->NCIRS = (0x01 << PWMG_NCIRS_PWM2A_Pos);
		else			  PWMG->NCIRS = (0x01 << PWMG_NCIRS_PWM2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->NCIRS = (0x01 << PWMG_NCIRS_PWM3A_Pos);
		else			  PWMG->NCIRS = (0x01 << PWMG_NCIRS_PWM3B_Pos);
		break;
	} 
}

/****************************************************************************************************************************************** 
* :	PWM_IntNCycleStat()
* ˵: ڿʼжǷ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : uint32_t				0 ڿʼжѷ    0 ڿʼжδ
* ע: 
******************************************************************************************************************************************/
uint32_t PWM_IntNCycleStat(uint32_t pwmx)
{	
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) return (PWMG->NCIF & PWMG_NCIF_PWM0A_Msk);
		else			  return (PWMG->NCIF & PWMG_NCIF_PWM0B_Msk);

	case((uint32_t)PWM1):
		if((pwmx%2) == 0) return (PWMG->NCIF & PWMG_NCIF_PWM1A_Msk);
		else			  return (PWMG->NCIF & PWMG_NCIF_PWM1B_Msk);

	case((uint32_t)PWM2):
		if((pwmx%2) == 0) return (PWMG->NCIF & PWMG_NCIF_PWM2A_Msk);
		else			  return (PWMG->NCIF & PWMG_NCIF_PWM2B_Msk);
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) return (PWMG->NCIF & PWMG_NCIF_PWM3A_Msk);
		else			  return (PWMG->NCIF & PWMG_NCIF_PWM3B_Msk);
	}
	
	return 0;
}


/****************************************************************************************************************************************** 
* :	PWM_IntHEndEn()
* ˵: ߵƽжʹ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntHEndEn(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->IE |= (0x01 << PWMG_IE_HE0A_Pos);
		else			  PWMG->IE |= (0x01 << PWMG_IE_HE0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->IE |= (0x01 << PWMG_IE_HE1A_Pos);
		else			  PWMG->IE |= (0x01 << PWMG_IE_HE1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->IE |= (0x01 << PWMG_IE_HE2A_Pos);
		else			  PWMG->IE |= (0x01 << PWMG_IE_HE2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->IE |= (0x01 << PWMG_IE_HE3A_Pos);
		else			  PWMG->IE |= (0x01 << PWMG_IE_HE3B_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	PWM_IntHEndDis()
* ˵: ߵƽжϽ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntHEndDis(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->IE &= ~(0x01 << PWMG_IE_HE0A_Pos);
		else			  PWMG->IE &= ~(0x01 << PWMG_IE_HE0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->IE &= ~(0x01 << PWMG_IE_HE1A_Pos);
		else			  PWMG->IE &= ~(0x01 << PWMG_IE_HE1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->IE &= ~(0x01 << PWMG_IE_HE2A_Pos);
		else			  PWMG->IE &= ~(0x01 << PWMG_IE_HE2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->IE &= ~(0x01 << PWMG_IE_HE3A_Pos);
		else			  PWMG->IE &= ~(0x01 << PWMG_IE_HE3B_Pos);
		break;
	} 
}

/****************************************************************************************************************************************** 
* :	PWM_IntHEndClr()
* ˵: ߵƽжϱ־
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntHEndClr(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->HEIRS = (0x01 << PWMG_HEIRS_PWM0A_Pos);
		else			  PWMG->HEIRS = (0x01 << PWMG_HEIRS_PWM0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->HEIRS = (0x01 << PWMG_HEIRS_PWM1A_Pos);
		else			  PWMG->HEIRS = (0x01 << PWMG_HEIRS_PWM1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->HEIRS = (0x01 << PWMG_HEIRS_PWM2A_Pos);
		else			  PWMG->HEIRS = (0x01 << PWMG_HEIRS_PWM2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->HEIRS = (0x01 << PWMG_HEIRS_PWM3A_Pos);
		else			  PWMG->HEIRS = (0x01 << PWMG_HEIRS_PWM3B_Pos);
		break;
	} 
}

/****************************************************************************************************************************************** 
* :	PWM_IntHEndStat()
* ˵: ߵƽжǷ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : uint32_t				0 ߵƽжѷ    0 ߵƽжδ
* ע: 
******************************************************************************************************************************************/
uint32_t PWM_IntHEndStat(uint32_t pwmx)
{	
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) return (PWMG->HEIF & PWMG_HEIF_PWM0A_Msk);
		else			  return (PWMG->HEIF & PWMG_HEIF_PWM0B_Msk);

	case((uint32_t)PWM1):
		if((pwmx%2) == 0) return (PWMG->HEIF & PWMG_HEIF_PWM1A_Msk);
		else			  return (PWMG->HEIF & PWMG_HEIF_PWM1B_Msk);

	case((uint32_t)PWM2):
		if((pwmx%2) == 0) return (PWMG->HEIF & PWMG_HEIF_PWM2A_Msk);
		else			  return (PWMG->HEIF & PWMG_HEIF_PWM2B_Msk);
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) return (PWMG->HEIF & PWMG_HEIF_PWM3A_Msk);
		else			  return (PWMG->HEIF & PWMG_HEIF_PWM3B_Msk);
	}
	
	return 0;
}

/****************************************************************************************************************************************** 
* :	PWM_IntHCycleEn()
* ˵: жʹ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntHCycleEn(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->HCIE |= (0x01 << PWMG_HCIE_PWM0A_Pos);
		else			  PWMG->HCIE |= (0x01 << PWMG_HCIE_PWM0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->HCIE |= (0x01 << PWMG_HCIE_PWM1A_Pos);
		else			  PWMG->HCIE |= (0x01 << PWMG_HCIE_PWM1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->HCIE |= (0x01 << PWMG_HCIE_PWM2A_Pos);
		else			  PWMG->HCIE |= (0x01 << PWMG_HCIE_PWM2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->HCIE |= (0x01 << PWMG_HCIE_PWM3A_Pos);
		else			  PWMG->HCIE |= (0x01 << PWMG_HCIE_PWM3B_Pos);
		break;
	}
}

/****************************************************************************************************************************************** 
* :	PWM_IntHCycleDis()
* ˵: жϽ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntHCycleDis(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->HCIE &= ~(0x01 << PWMG_HCIE_PWM0A_Pos);
		else			  PWMG->HCIE &= ~(0x01 << PWMG_HCIE_PWM0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->HCIE &= ~(0x01 << PWMG_HCIE_PWM1A_Pos);
		else			  PWMG->HCIE &= ~(0x01 << PWMG_HCIE_PWM1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->HCIE &= ~(0x01 << PWMG_HCIE_PWM2A_Pos);
		else			  PWMG->HCIE &= ~(0x01 << PWMG_HCIE_PWM2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->HCIE &= ~(0x01 << PWMG_HCIE_PWM3A_Pos);
		else			  PWMG->HCIE &= ~(0x01 << PWMG_HCIE_PWM3B_Pos);
		break;
	} 
}

/****************************************************************************************************************************************** 
* :	PWM_IntHCycleClr()
* ˵: жϱ־
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : 
* ע: 
******************************************************************************************************************************************/
void PWM_IntHCycleClr(uint32_t pwmx)
{
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) PWMG->HCIRS = (0x01 << PWMG_HCIRS_PWM0A_Pos);
		else			  PWMG->HCIRS = (0x01 << PWMG_HCIRS_PWM0B_Pos);
		break;
	
	case((uint32_t)PWM1):
		if((pwmx%2) == 0) PWMG->HCIRS = (0x01 << PWMG_HCIRS_PWM1A_Pos);
		else			  PWMG->HCIRS = (0x01 << PWMG_HCIRS_PWM1B_Pos);
		break;
	
	case((uint32_t)PWM2):
		if((pwmx%2) == 0) PWMG->HCIRS = (0x01 << PWMG_HCIRS_PWM2A_Pos);
		else			  PWMG->HCIRS = (0x01 << PWMG_HCIRS_PWM2B_Pos);
		break;
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) PWMG->HCIRS = (0x01 << PWMG_HCIRS_PWM3A_Pos);
		else			  PWMG->HCIRS = (0x01 << PWMG_HCIRS_PWM3B_Pos);
		break;
	} 
}

/****************************************************************************************************************************************** 
* :	PWM_IntHCycleStat()
* ˵: жǷ
*     : uint32_t pwmx			ָҪõPWMЧֵPWM0APWM0BPWM1APWM1BPWM2APWM2BPWM3APWM3B
*     : uint32_t				0 жѷ    0 жδ
* ע: 
******************************************************************************************************************************************/
uint32_t PWM_IntHCycleStat(uint32_t pwmx)
{	
	switch((uint32_t)PWMX[pwmx])
	{
	case((uint32_t)PWM0):
		if((pwmx%2) == 0) return (PWMG->HCIF & PWMG_HCIF_PWM0A_Msk);
		else			  return (PWMG->HCIF & PWMG_HCIF_PWM0B_Msk);

	case((uint32_t)PWM1):
		if((pwmx%2) == 0) return (PWMG->HCIF & PWMG_HCIF_PWM1A_Msk);
		else			  return (PWMG->HCIF & PWMG_HCIF_PWM1B_Msk);

	case((uint32_t)PWM2):
		if((pwmx%2) == 0) return (PWMG->HCIF & PWMG_HCIF_PWM2A_Msk);
		else			  return (PWMG->HCIF & PWMG_HCIF_PWM2B_Msk);
	
	case((uint32_t)PWM3):
		if((pwmx%2) == 0) return (PWMG->HCIF & PWMG_HCIF_PWM3A_Msk);
		else			  return (PWMG->HCIF & PWMG_HCIF_PWM3B_Msk);
	}
	
	return 0;
}

