/****************************************************************************************************************************************** 
* ļ:	SWM220_uart.c
* ˵:	SWM220ƬUARTڹ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע: ûбдLINصĺ
* 汾:	V1.0.0		2016130
* ¼: 
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology 
*******************************************************************************************************************************************/
#include "SWM220.h"
#include "SWM220_uart.h"


/****************************************************************************************************************************************** 
* :	UART_Init()
* ˵:	UARTڳʼ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*			UART_InitStructure * initStruct    UART趨ֵĽṹ
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Init(UART_TypeDef * UARTx, UART_InitStructure * initStruct)
{	
	switch((uint32_t)UARTx)
	{
	case ((uint32_t)UART0):
		SYS->CLKEN |= (0x01 << SYS_CLKEN_UART0_Pos);
		break;
	
	case ((uint32_t)UART1):
		SYS->CLKEN |= (0x01 << SYS_CLKEN_UART1_Pos);
		break;
	
	case ((uint32_t)UART2):
		SYS->CLKEN |= (0x01 << SYS_CLKEN_UART2_Pos);
		break;
	
	case ((uint32_t)UART3):
		SYS->CLKEN |= (0x01 << SYS_CLKEN_UART3_Pos);
		break;
	}
	
	UART_Close(UARTx);	//һЩؼĴֻڴڹرʱ
	
	UARTx->CTRL &= ~(UART_CTRL_DATA9b_Msk | UART_CTRL_PARITY_Msk | UART_CTRL_STOP2b_Msk);
	UARTx->CTRL |= (initStruct->DataBits << UART_CTRL_DATA9b_Pos) |
				   (initStruct->Parity   << UART_CTRL_PARITY_Pos) |
				   (initStruct->StopBits << UART_CTRL_STOP2b_Pos);
	
	UARTx->CTRL |= (0x01 << UART_CTRL_BAUDEN_Pos);
	UARTx->BAUD &= ~UART_BAUD_BAUD_Msk;
	UARTx->BAUD |= ((SystemCoreClock/16/initStruct->Baudrate - 1) << UART_BAUD_BAUD_Pos);
	
	UARTx->FIFO &= ~(UART_FIFO_RXTHR_Msk | UART_FIFO_TXTHR_Msk);
	UARTx->FIFO |= (initStruct->RXThreshold << UART_FIFO_RXTHR_Pos) | 
				   (initStruct->TXThreshold << UART_FIFO_TXTHR_Pos);
	
	UARTx->CTRL &= ~UART_CTRL_TOTIME_Msk;
	UARTx->CTRL |= (initStruct->TimeoutTime << UART_CTRL_TOTIME_Pos);
	
	UARTx->CTRL &= ~(UART_CTRL_RXIE_Msk | UART_CTRL_TXIE_Msk | UART_CTRL_TOIE_Msk);
	UARTx->CTRL |= (initStruct->RXThresholdIEn << UART_CTRL_RXIE_Pos) |
				   (initStruct->TXThresholdIEn << UART_CTRL_TXIE_Pos) |
				   (initStruct->TimeoutIEn << UART_CTRL_TOIE_Pos);
	
	switch((uint32_t)UARTx)
	{
	case ((uint32_t)UART0):		
		if(initStruct->RXThresholdIEn | initStruct->TXThresholdIEn | initStruct->TimeoutIEn)
		{
			NVIC_EnableIRQ(UART0_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(UART0_IRQn);
		}
		break;
	
	case ((uint32_t)UART1):	
		if(initStruct->RXThresholdIEn | initStruct->TXThresholdIEn | initStruct->TimeoutIEn)
		{
			NVIC_EnableIRQ(UART1_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(UART1_IRQn);
		}
		break;
	
	case ((uint32_t)UART2):	
		if(initStruct->RXThresholdIEn | initStruct->TXThresholdIEn | initStruct->TimeoutIEn)
		{
			NVIC_EnableIRQ(UART2_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(UART2_IRQn);
		}
		break;
	
	case ((uint32_t)UART3):	
		if(initStruct->RXThresholdIEn | initStruct->TXThresholdIEn | initStruct->TimeoutIEn)
		{
			NVIC_EnableIRQ(UART3_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(UART3_IRQn);
		}
		break;
	}
}

/****************************************************************************************************************************************** 
* :	UART_Open()
* ˵:	UARTڴ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Open(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_Close()
* ˵:	UARTڹر
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_Close(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_WriteByte()
* ˵:	һֽ
*     : UART_TypeDef * UARTx	ָҪõUARTڣȡֵUART0UART1UART2UART3
*			uint8_t data			Ҫ͵ֽ			
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_WriteByte(UART_TypeDef * UARTx, uint8_t data)
{
	UARTx->DATA = data;
}

/****************************************************************************************************************************************** 
* :	UART_ReadByte()
* ˵:	ȡһֽݣָǷValid
*     : UART_TypeDef * UARTx	ָҪõUARTڣȡֵUART0UART1UART2UART3
*			uint32_t * data			յ
*     : uint32_t				0 ޴    UART_ERR_PARITY żУ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_ReadByte(UART_TypeDef * UARTx, uint32_t * data)
{
	uint32_t reg = UARTx->DATA;
	
	*data = (reg & UART_DATA_DATA_Msk);
	
	if(reg & UART_DATA_PAERR_Msk) return UART_ERR_PARITY;
	
	return 0;
}

/****************************************************************************************************************************************** 
* :	UART_IsTXBusy()
* ˵:	UARTǷڷ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 UARTڷ    0 ѷ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsTXBusy(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_TXIDLE_Msk) ? 0 : 1;
}

/****************************************************************************************************************************************** 
* :	UART_IsRXFIFOEmpty()
* ˵:	FIFOǷΪգ˵ݿԶȡ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 FIFO    0 FIFOǿ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsRXFIFOEmpty(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_RXNE_Msk) ? 0 : 1;
}

/****************************************************************************************************************************************** 
* :	UART_IsTXFIFOFull()
* ˵:	FIFOǷΪԼд
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 FIFO    0 FIFO
* ע: 
******************************************************************************************************************************************/
uint32_t UART_IsTXFIFOFull(UART_TypeDef * UARTx)
{
	return (UARTx->CTRL & UART_CTRL_TXF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_SetBaudrate()
* ˵:	ò
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*			uint32_t baudrate		ҪõĲ
*     : 
* ע: ҪڴڹʱĲʣʹô˺ǰȵUART_Close()رմ
******************************************************************************************************************************************/
void UART_SetBaudrate(UART_TypeDef * UARTx, uint32_t baudrate)
{
	UARTx->BAUD &= ~UART_BAUD_BAUD_Msk;
	UARTx->BAUD |= ((SystemCoreClock/16/baudrate - 1) << UART_BAUD_BAUD_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_GetBaudrate()
* ˵:	ѯ
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				ǰ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_GetBaudrate(UART_TypeDef * UARTx)
{
	return SystemCoreClock/16/(((UARTx->BAUD & UART_BAUD_BAUD_Msk) >> UART_BAUD_BAUD_Pos) + 1);
}

/****************************************************************************************************************************************** 
* :	UART_INTRXThresholdEn()
* ˵:	RX FIFOݸ >= RXThresholdʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTRXThresholdEn(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_RXIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTRXThresholdDis()
* ˵:	RX FIFOݸ >= RXThresholdʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTRXThresholdDis(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_RXIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTRXThresholdStat()
* ˵:	ǷRX FIFOݸ >= RXThreshold
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 RX FIFOݸ >= RXThreshold		0 RX FIFOݸ < RXThreshold
* ע: RXIF = RXTHRF & RXIE
******************************************************************************************************************************************/
uint32_t UART_INTRXThresholdStat(UART_TypeDef * UARTx)
{
	return (UARTx->BAUD & UART_BAUD_RXIF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_INTTXThresholdEn()
* ˵:	TX FIFOݸ <= TXThresholdʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTXThresholdEn(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_TXIE_Pos);	
}

/****************************************************************************************************************************************** 
* :	UART_INTTXThresholdDis()
* ˵:	TX FIFOݸ <= TXThresholdʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTXThresholdDis(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_TXIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTTXThresholdStat()
* ˵:	ǷTX FIFOݸ <= TXThreshold
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 TX FIFOݸ <= TXThreshold		0 TX FIFOݸ > TXThreshold
* ע: TXIF = TXTHRF & TXIE
******************************************************************************************************************************************/
uint32_t UART_INTTXThresholdStat(UART_TypeDef * UARTx)
{
	return (UARTx->BAUD & UART_BAUD_TXIF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	UART_INTTimeoutEn()
* ˵:	շʱʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTimeoutEn(UART_TypeDef * UARTx)
{
	UARTx->CTRL |= (0x01 << UART_CTRL_TOIE_Pos);	
}

/****************************************************************************************************************************************** 
* :	UART_INTTimeoutDis()
* ˵:	շʱʱ ж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : 
* ע: 
******************************************************************************************************************************************/
void UART_INTTimeoutDis(UART_TypeDef * UARTx)
{
	UARTx->CTRL &= ~(0x01 << UART_CTRL_TOIE_Pos);
}

/****************************************************************************************************************************************** 
* :	UART_INTTimeoutStat()
* ˵:	Ƿ˽ճʱ TimeoutTime/(Baudrate/10) ûRXϽյʱж
*     : UART_TypeDef * UARTx	ָҪõUARTڣЧֵUART0UART1UART2UART3
*     : uint32_t				1 ˽ճʱ		0 δճʱ
* ע: 
******************************************************************************************************************************************/
uint32_t UART_INTTimeoutStat(UART_TypeDef * UARTx)
{
	return (UARTx->BAUD & UART_BAUD_TOIF_Msk) ? 1 : 0;
}

