/****************************************************************************************************************************************** 
* ļ: SWM220_wdt.c
* ˵:	SWM220ƬWDTŹ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾:	V1.0.0		2016130
* ¼:  
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology
*******************************************************************************************************************************************/
#include "SWM220.h"
#include "SWM220_wdt.h"


/****************************************************************************************************************************************** 
* :	WDT_Init()
* ˵:	WDTŹʼ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*			uint32_t peroid			ȡֵ0--4294967295λΪƬϵͳʱ
*			uint32_t mode			WDT_MODE_RESET   		   С0ʱλ
*									WDT_MODE_INTERRUPT		   СLOAD/4ʱж
*									WDT_MODE_INTERRUPT_RESET   СLOAD/4ʱжϣС0ʱλ
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Init(WDT_TypeDef * WDTx, uint32_t peroid, uint32_t mode)
{
	SYS->CLKEN |= (0x01 << SYS_CLKEN_WDT_Pos);
	
	WDT_Stop(WDTx);		//ǰȹر
	
	WDT_INTClr(WDTx);
	
	WDTx->LOAD = peroid;
	
	if(mode == WDT_MODE_RESET)
	{
		WDTx->CR |= (1 << WDT_CR_RSTEN_Pos);
	}
	else if(mode == WDT_MODE_INTERRUPT)
	{
		WDT_INTClr(WDTx);
		NVIC_EnableIRQ(WDT_IRQn);
	}
	else if(mode == WDT_MODE_INTERRUPT_RESET)
	{
		WDTx->CR |= (1 << WDT_CR_RSTEN_Pos);
		
		WDT_INTClr(WDTx);
		NVIC_EnableIRQ(WDT_IRQn);
	}
}

/****************************************************************************************************************************************** 
* :	WDT_Start()
* ˵:	ָWDTʼʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Start(WDT_TypeDef * WDTx)
{
	WDTx->CR |= (0x01 << WDT_CR_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	WDT_Stop()
* ˵:	رָWDTֹͣʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Stop(WDT_TypeDef * WDTx)
{
	WDTx->CR &= ~(0x01 << WDT_CR_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	WDT_Feed()
* ˵:	ι´װֵʼʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Feed(WDT_TypeDef * WDTx)
{
	WDTx->FEED = 0x55;
}

/****************************************************************************************************************************************** 
* :	WDT_GetValue()
* ˵:	ȡָŹʱĵǰʱֵ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : int32_t					Źǰֵ
* ע: 
******************************************************************************************************************************************/
int32_t WDT_GetValue(WDT_TypeDef * WDTx)
{
	return WDTx->VALUE;
}

/****************************************************************************************************************************************** 
* :	WDT_INTClr()
* ˵:	жϱ־
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_INTClr(WDT_TypeDef * WDTx)
{
	WDTx->IF = 0;
}

/****************************************************************************************************************************************** 
* :	WDT_INTStat()
* ˵:	ж״̬ѯ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : int32_t					1 ж    0 δж
* ע: 
******************************************************************************************************************************************/
uint32_t WDT_INTStat(WDT_TypeDef * WDTx)
{
	return WDTx->IF;
}
