/****************************************************************************************************************************************** 
* ļ:	SWM260_spi.c
* ˵:	SWM260ƬSPI
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾:	V1.0.0		2016130
* ¼:  
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology
*******************************************************************************************************************************************/
#include "SWM260.h"
#include "SWM260_spi.h"


/****************************************************************************************************************************************** 
* :	SPI_Init()
* ˵:	SPIͬнӿڳʼ֡趨ʱ趨ٶ趨ж趨FIFO趨
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*			SPI_InitStructure * initStruct	SPI趨ֵĽṹ
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_Init(SPI_TypeDef * SPIx, SPI_InitStructure * initStruct)
{
	switch((uint32_t)SPIx)
	{
	case ((uint32_t)SPI0):
		SYS->CLKEN0 |= (0x01 << SYS_CLKEN0_SPI0_Pos);
		break;

	case ((uint32_t)SPI1):
		SYS->CLKEN0 |= (0x01 << SYS_CLKEN0_SPI1_Pos);
		break;
	}
	
	SPI_Close(SPIx);	//һЩؼĴֻSPIرʱ
	
	SPIx->CTRL &= ~(SPI_CTRL_FFS_Msk | SPI_CTRL_CPHA_Msk | SPI_CTRL_CPOL_Msk | SPI_CTRL_SIZE_Msk | SPI_CTRL_MSTR_Msk | 
	                SPI_CTRL_CLKDIV_Msk | SPI_CTRL_SSN_H_Msk | SPI_CTRL_RFTHR_Msk | SPI_CTRL_TFTHR_Msk);
	SPIx->CTRL |= (initStruct->FrameFormat     << SPI_CTRL_FFS_Pos)    |
				  (initStruct->SampleEdge      << SPI_CTRL_CPHA_Pos)   |
				  (initStruct->IdleLevel       << SPI_CTRL_CPOL_Pos)   |
				  ((initStruct->WordSize-1)    << SPI_CTRL_SIZE_Pos)   |
				  (initStruct->Master          << SPI_CTRL_MSTR_Pos)   |
				  (initStruct->clkDiv          << SPI_CTRL_CLKDIV_Pos) |
				  (0                           << SPI_CTRL_SSN_H_Pos)  |
				  ((initStruct->RXThreshold > 0 ? initStruct->RXThreshold-1 : 0) << SPI_CTRL_RFTHR_Pos)  |
				  (initStruct->TXThreshold     << SPI_CTRL_TFTHR_Pos)  |
				  (1                           << SPI_CTRL_RFCLR_Pos)  |
	              (1                           << SPI_CTRL_TFCLR_Pos);
	SPIx->CTRL &= ~(SPI_CTRL_RFCLR_Msk | SPI_CTRL_TFCLR_Msk);
	
	SPIx->IF = 0x37F;	//жϱ־
	SPIx->IE = 0x000;
	SPIx->IE |= (initStruct->RXThresholdIEn << SPI_IE_RFTHR_Pos) |
				(initStruct->TXThresholdIEn << SPI_IE_TFTHR_Pos) |
	            (initStruct->TXCompleteIEn  << SPI_IE_FTC_Pos);
	
	switch((uint32_t)SPIx)
	{
	case ((uint32_t)SPI0):		
		if(initStruct->RXThresholdIEn | initStruct->TXThresholdIEn | initStruct->TXCompleteIEn)
		{
			NVIC_EnableIRQ(SPI0_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(SPI0_IRQn);
		}
		break;
	
	case ((uint32_t)SPI1):		
		if(initStruct->RXThresholdIEn | initStruct->TXThresholdIEn | initStruct->TXCompleteIEn)
		{
			NVIC_EnableIRQ(SPI1_HALL_GPIOD_IRQn);
		}
		else
		{
			NVIC_DisableIRQ(SPI1_HALL_GPIOD_IRQn);
		}
		break;
	}
}

/****************************************************************************************************************************************** 
* :	SPI_Open()
* ˵:	SPI򿪣շ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_Open(SPI_TypeDef * SPIx)
{
	SPIx->CTRL |= (0x01 << SPI_CTRL_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_Close()
* ˵:	SPIرգֹշ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_Close(SPI_TypeDef * SPIx)
{
	SPIx->CTRL &= ~SPI_CTRL_EN_Msk;
}

/****************************************************************************************************************************************** 
* :	SPI_Read()
* ˵:	ȡһ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				ȡ
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_Read(SPI_TypeDef * SPIx)
{
	return SPIx->DATA;
}

/****************************************************************************************************************************************** 
* :	SPI_Write()
* ˵:	дһ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*			uint32_t				Ҫд
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_Write(SPI_TypeDef * SPIx, uint32_t data)
{
	SPIx->DATA = data;
}

/****************************************************************************************************************************************** 
* :	SPI_WriteWithWait()
* ˵:	дһݲȴȫͳȥ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1SPI1
*			uint32_t				Ҫд
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_WriteWithWait(SPI_TypeDef * SPIx, uint32_t data)
{
	SPIx->STAT |= (1 << SPI_STAT_WTC_Pos);
	
	SPIx->DATA = data;
	
	while((SPIx->STAT & SPI_STAT_WTC_Msk) == 0);
}

/****************************************************************************************************************************************** 
* : SPI_ReadWrite()
* ˵: һݣط͹нյ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*			uint32_t data 			Ҫ͵
*     : uint32_t				յ
* ע: ͬһSPIģ飬˺ӦSPI_Write()ãΪSPI_Write()SPI_STAT_RFNE״̬
******************************************************************************************************************************************/
uint32_t SPI_ReadWrite(SPI_TypeDef * SPIx, uint32_t data)
{
	SPIx->DATA = data;
	while(!(SPIx->STAT & SPI_STAT_RFNE_Msk));
	
	return SPIx->DATA;
}

/****************************************************************************************************************************************** 
* :	SPI_IsRXEmpty()
* ˵:	FIFOǷգԼSPI_Read()
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFO    0 FIFOǿ
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_IsRXEmpty(SPI_TypeDef * SPIx)
{
	return (SPIx->STAT & SPI_STAT_RFNE_Msk) ? 0 : 1;
}

/****************************************************************************************************************************************** 
* :	SPI_IsTXFull()
* ˵:	FIFOǷԼSPI_Write()
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFO    0 FIFO
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_IsTXFull(SPI_TypeDef * SPIx)
{
	return (SPIx->STAT & SPI_STAT_TFNF_Msk) ? 0 : 1;
}

/****************************************************************************************************************************************** 
* :	SPI_IsTXEmpty()
* ˵:	FIFOǷ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFO    0 FIFOǿ
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_IsTXEmpty(SPI_TypeDef * SPIx)
{
	return (SPIx->STAT & SPI_STAT_TFE_Msk) ? 1 : 0;
}


/****************************************************************************************************************************************** 
* :	SPI_INTRXHalfFullEn()
* ˵:	FIFOжʹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXHalfFullEn(SPI_TypeDef * SPIx)
{
	SPIx->IE |= (0x01 << SPI_IE_RFHF_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXHalfFullDis()
* ˵:	FIFOжϽֹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXHalfFullDis(SPI_TypeDef * SPIx)
{
	SPIx->IE &= ~(0x01 << SPI_IE_RFHF_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXHalfFullClr()
* ˵:	FIFOжϱ־
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXHalfFullClr(SPI_TypeDef * SPIx)
{
	SPIx->IF = (1 << SPI_IF_RFHF_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXHalfFullStat()
* ˵:	FIFOж״̬
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFOﵽ    0 FIFOδﵽ
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_INTRXHalfFullStat(SPI_TypeDef * SPIx)
{
	return (SPIx->IF & SPI_IF_RFHF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXFullEn()
* ˵:	FIFOжʹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXFullEn(SPI_TypeDef * SPIx)
{
	SPIx->IE |= (0x01 << SPI_IE_RFF_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXFullDis()
* ˵:	FIFOжϽֹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXFullDis(SPI_TypeDef * SPIx)
{
	SPIx->IE &= ~(0x01 << SPI_IE_RFF_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXFullClr()
* ˵:	FIFOжϱ־
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXFullClr(SPI_TypeDef * SPIx)
{
	SPIx->IF = (1 << SPI_IF_RFF_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXFullStat()
* ˵:	FIFOж״̬
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFO    0 FIFOδ
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_INTRXFullStat(SPI_TypeDef * SPIx)
{
	return (SPIx->IF & SPI_IF_RFF_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXOverflowEn()
* ˵:	FIFOжʹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXOverflowEn(SPI_TypeDef * SPIx)
{
	SPIx->IE |= (0x01 << SPI_IE_RFOV_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXOverflowDis()
* ˵:	FIFOжϽֹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXOverflowDis(SPI_TypeDef * SPIx)
{
	SPIx->IE &= ~(0x01 << SPI_IE_RFOV_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXOverflowClr()
* ˵:	FIFOжϱ־
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXOverflowClr(SPI_TypeDef * SPIx)
{
	SPIx->IF = (0x01 << SPI_IF_RFOV_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXOverflowStat()
* ˵:	FIFOж״̬
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFO    0 FIFOδ
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_INTRXOverflowStat(SPI_TypeDef * SPIx)
{
	return (SPIx->IF & SPI_IF_RFOV_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXEmptyEn()
* ˵:	FIFOжʹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXEmptyEn(SPI_TypeDef * SPIx)
{
	SPIx->IE |= (0x01 << SPI_IE_TFE_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXEmptyDis()
* ˵:	FIFOжϽֹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXEmptyDis(SPI_TypeDef * SPIx)
{
	SPIx->IE &= ~(0x01 << SPI_IE_TFE_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXEmptyClr()
* ˵:	FIFOжϱ־
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXEmptyClr(SPI_TypeDef * SPIx)
{
	SPIx->IF = (1 << SPI_IF_TFE_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXEmptyStat()
* ˵:	FIFOж״̬
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFO    0 FIFOǿ
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_INTTXEmptyStat(SPI_TypeDef * SPIx)
{
	return (SPIx->IF & SPI_IF_TFE_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXCompleteEn()
* ˵:	FIFOҷλĴжʹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXCompleteEn(SPI_TypeDef * SPIx)
{
	SPIx->IE |= (0x01 << SPI_IE_FTC_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXCompleteDis()
* ˵:	FIFOҷλĴжϽֹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXCompleteDis(SPI_TypeDef * SPIx)
{
	SPIx->IE &= ~(0x01 << SPI_IE_FTC_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXCompleteClr()
* ˵:	FIFOҷλĴж״̬
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXCompleteClr(SPI_TypeDef * SPIx)
{
	SPIx->IF = (1 << SPI_IF_FTC_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXCompleteStat()
* ˵:	FIFOҷλĴж״̬
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFOҷλĴ    0 FIFOλĴǿ
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_INTTXCompleteStat(SPI_TypeDef * SPIx)
{
	return (SPIx->IF & SPI_IF_FTC_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXThresholdEn()
* ˵:	FIFOݸCTRL.RXTHRжʹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXThresholdEn(SPI_TypeDef * SPIx)
{
	SPIx->IE |= (0x01 << SPI_IE_RFTHR_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXThresholdDis()
* ˵:	FIFOݸCTRL.RXTHRжϽֹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXThresholdDis(SPI_TypeDef * SPIx)
{
	SPIx->IE &= ~(0x01 << SPI_IE_RFTHR_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXThresholdClr()
* ˵:	FIFOݸCTRL.RXTHRжϱ־
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTRXThresholdClr(SPI_TypeDef * SPIx)
{
	SPIx->IF = (1 << SPI_IF_RFTHR_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTRXThresholdStat()
* ˵:	FIFOݸCTRL.RXTHRж״̬
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFOݸCTRL.RXTHR    0 FIFOݸCTRL.RXTHR
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_INTRXThresholdStat(SPI_TypeDef * SPIx)
{
	return (SPIx->IF & SPI_IF_RFTHR_Msk) ? 1 : 0;
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXThresholdEn()
* ˵:	FIFOݸCTRL.TXTHRжʹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXThresholdEn(SPI_TypeDef * SPIx)
{
	SPIx->IE |= (0x01 << SPI_IE_TFTHR_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXThresholdDis()
* ˵:FIFOݸCTRL.TXTHRжϽֹ
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXThresholdDis(SPI_TypeDef * SPIx)
{
	SPIx->IE &= ~(0x01 << SPI_IE_TFTHR_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXThresholdClr()
* ˵:	FIFOݸCTRL.TXTHRжϱ־
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : 
* ע: 
******************************************************************************************************************************************/
void SPI_INTTXThresholdClr(SPI_TypeDef * SPIx)
{
	SPIx->IF = (1 << SPI_IF_TFTHR_Pos);
}

/****************************************************************************************************************************************** 
* :	SPI_INTTXThresholdStat()
* ˵:	FIFOݸCTRL.TXTHRж״̬
*     : SPI_TypeDef * SPIx		ָҪõSPIЧֵSPI0SPI1
*     : uint32_t				1 FIFOݸCTRL.TXTHR    0 FIFOݸCTRL.TXTHR
* ע: 
******************************************************************************************************************************************/
uint32_t SPI_INTTXThresholdStat(SPI_TypeDef * SPIx)
{
	return (SPIx->IF & SPI_IF_TFTHR_Msk) ? 1 : 0;
}

