/****************************************************************************************************************************************** 
* ļ: SWM260_wdt.c
* ˵:	SWM260ƬWDTŹ
* ֧:	http://www.synwit.com.cn/e/tool/gbook/?bid=1
* ע:
* 汾:	V1.0.0		2016130
* ¼:  
*
*
*******************************************************************************************************************************************
* @attention
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS WITH CODING INFORMATION 
* REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME. AS A RESULT, SYNWIT SHALL NOT BE HELD LIABLE 
* FOR ANY DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE CONTENT 
* OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING INFORMATION CONTAINED HEREIN IN CONN-
* -ECTION WITH THEIR PRODUCTS.
*
* COPYRIGHT 2012 Synwit Technology
*******************************************************************************************************************************************/
#include "SWM260.h"
#include "SWM260_wdt.h"


/****************************************************************************************************************************************** 
* :	WDT_Init()
* ˵:	WDTŹʼ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*			uint32_t int_period		жڣȡֵ1--2^31λ1/32768룬ȡֵ0ʾرWDTжϹ
*			uint32_t rst_period		λڣȡֵ1--2^31λ1/32768룬ȡֵ0ʾرWDTλ
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Init(WDT_TypeDef * WDTx, uint32_t int_period, uint32_t rst_period)
{
	SYS->CLKEN0 |= (1 << SYS_CLKEN0_WDT_Pos);
	
	WDT_Stop(WDTx);		//ǰȹر
	
	if(int_period == 0)
	{
		WDTx->CR &= ~(1 << WDT_CR_INTEN_Pos);
		
		NVIC_DisableIRQ(WDT_IRQn);
	}
	else
	{
		WDTx->CR |=  (1 << WDT_CR_INTEN_Pos);
		
		WDTx->INTVAL = int_period;
		
		WDTx->IF = 1;
		NVIC_EnableIRQ(WDT_IRQn);
	}
	
	if(rst_period == 0)
	{
		WDTx->CR &= ~(1 << WDT_CR_RSTEN_Pos);
		
		WDTx->RSTVAL = int_period;
	}
	else
	{
		WDTx->CR |=  (1 << WDT_CR_RSTEN_Pos);
		
		WDTx->RSTVAL = rst_period;
	}
	
	WDTx->CR |= (1 << WDT_CR_LOCK_Pos);
	while(WDTx->CR & WDT_CR_LOCK_Msk) __NOP();
}

/****************************************************************************************************************************************** 
* :	WDT_Start()
* ˵:	ָWDTʼʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Start(WDT_TypeDef * WDTx)
{
	WDTx->CR |=  (1 << WDT_CR_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	WDT_Stop()
* ˵:	رָWDTֹͣʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Stop(WDT_TypeDef * WDTx)
{
	WDTx->CR &= ~(1 << WDT_CR_EN_Pos);
}

/****************************************************************************************************************************************** 
* :	WDT_Feed()
* ˵:	ι´װֵʼʱ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_Feed(WDT_TypeDef * WDTx)
{
	WDTx->FEED = 0x55;
}

/****************************************************************************************************************************************** 
* :	WDT_INTClr()
* ˵:	жϱ־
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : 
* ע: 
******************************************************************************************************************************************/
void WDT_INTClr(WDT_TypeDef * WDTx)
{
	WDTx->IF = 1;
}

/****************************************************************************************************************************************** 
* :	WDT_INTStat()
* ˵:	ж״̬ѯ
*     : WDT_TypeDef * WDTx		ָҪõĿŹЧֵWDT
*     : int32_t					1 ж    0 δж
* ע: 
******************************************************************************************************************************************/
uint32_t WDT_INTStat(WDT_TypeDef * WDTx)
{
	return WDTx->IF;
}
