#ifndef __SWM2X1_ADC_H__
#define	__SWM2X1_ADC_H__

typedef struct {
	uint8_t  clk_src;		//ADCתʱԴADC_CLKSRC_HRC_DIV32ADC_CLKSRC_XTAL_DIV32...
	uint8_t  clk_div;		//ADCתʱӷƵȡֵ1--31
	uint8_t  ref_src;		//ADCתοԴADC_REFSRC_VREFPADC_REFSRC_VDD
	uint16_t channels;		//ADCתͨѡУADC_CH0ADC_CH1... ... ADC_CH11ϣλ㣩
	uint8_t  samplAvg;		//ȡƽADCתADCһͨתΣǵƽֵΪͨת
	uint16_t trig_src;		//ADCʽADC_TRIGGER_SWADC_TRIGGER_TIMR2ADC_TRIGGER_TIMR3ADC_TRIGGER_PWM0A...
	uint8_t  Continue;		//ģʽ£1 תģʽһֱתֱSTARTλ
							//                  0 תģʽתɺSTARTλԶֹͣת
	uint16_t EOC_IEn;		//EOCжʹܣÿͨãЧֵΪADC_CH0ADC_CH1... ... ADC_CH11ϣλ㣩
	uint16_t OVF_IEn;		//OVFжʹܣÿͨãЧֵΪADC_CH0ADC_CH1... ... ADC_CH11ϣλ㣩
} ADC_InitStructure;

#define ADC_CH0		0x001
#define ADC_CH1		0x002
#define ADC_CH2		0x004
#define ADC_CH3		0x008
#define ADC_CH4		0x010
#define ADC_CH5		0x020
#define ADC_CH6		0x040
#define ADC_CH7		0x080
#define ADC_CH8		0x100
#define ADC_CH9		0x200
#define ADC_CH10	0x400
#define ADC_CH11	0x800


#if defined(CHIP_SWM201)

/*  ADC_CLKSRC_еķƵֵ48163264128ӲƵϲ
	һSYS->CLKSEL.ADCĴѡʱԴʱԴ148÷Ƶ
	ڶADCģѡʱԴ̶4Ƶ
	ADC->CTRL3.CLKDIV1Ĵ124Ƶ
*/
#define ADC_CLKSRC_HRC_DIV4		((2 << 4) | ((0 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV4	((2 << 4) | ((0 << 2) | 1))
#define ADC_CLKSRC_HRC_DIV16	((2 << 4) | ((2 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV16	((2 << 4) | ((2 << 2) | 1))
#define ADC_CLKSRC_HRC_DIV32	((2 << 4) | ((3 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV32	((2 << 4) | ((3 << 2) | 1))
#define ADC_CLKSRC_HRC_DIV8		((1 << 4) | ((0 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV8	((1 << 4) | ((0 << 2) | 1))
#define ADC_CLKSRC_HRC_DIV64	((1 << 4) | ((3 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV64	((1 << 4) | ((3 << 2) | 1))
#define ADC_CLKSRC_HRC_DIV128	((0 << 4) | ((3 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV128	((0 << 4) | ((3 << 2) | 1))

#elif defined(CHIP_SWM211)

/*  ADC_CLKSRC_еķƵֵ2481632ӲƵϲ
	һSYS->CLKSEL.ADCĴѡʱԴʱԴ148÷Ƶ
	ڶADC->CTRL3.CLKDIV1Ĵ124Ƶ
*/
#define ADC_CLKSRC_HRC			((2 << 4) | ((0 << 2) | 0))
#define ADC_CLKSRC_XTAL			((2 << 4) | ((0 << 2) | 1))
#define ADC_CLKSRC_PLL			((2 << 4) | ((0 << 2) | 2))
#define ADC_CLKSRC_HRC_DIV4		((2 << 4) | ((2 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV4	((2 << 4) | ((2 << 2) | 1))
#define ADC_CLKSRC_PLL_DIV4		((2 << 4) | ((2 << 2) | 2))
#define ADC_CLKSRC_HRC_DIV8		((2 << 4) | ((3 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV8	((2 << 4) | ((3 << 2) | 1))
#define ADC_CLKSRC_PLL_DIV8		((2 << 4) | ((3 << 2) | 2))
#define ADC_CLKSRC_HRC_DIV2		((1 << 4) | ((0 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV2	((1 << 4) | ((0 << 2) | 1))
#define ADC_CLKSRC_PLL_DIV2		((1 << 4) | ((0 << 2) | 2))
#define ADC_CLKSRC_HRC_DIV16	((1 << 4) | ((3 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV16	((1 << 4) | ((3 << 2) | 1))
#define ADC_CLKSRC_PLL_DIV16	((1 << 4) | ((3 << 2) | 2))
#define ADC_CLKSRC_HRC_DIV32	((0 << 4) | ((3 << 2) | 0))
#define ADC_CLKSRC_XTAL_DIV32	((0 << 4) | ((3 << 2) | 1))
#define ADC_CLKSRC_PLL_DIV32	((0 << 4) | ((3 << 2) | 2))

#endif


#define ADC_REFSRC_VREFP		((3 << 4) | 0)	//Vrefp 
#define ADC_REFSRC_VDD			((3 << 4) | 1)	//оƬVDD
#define ADC_REFSRC_3V6			((0 << 4) | 7)	//ڲ3.6V

#define ADC_AVG_SAMPLE1			0	
#define ADC_AVG_SAMPLE2			1	//һת2ΣνƽֵΪת
#define ADC_AVG_SAMPLE4			3
#define ADC_AVG_SAMPLE8			7
#define ADC_AVG_SAMPLE16		15


#if defined(CHIP_SWM201)

#define ADC_TRIGGER_SW			4	//ADC->START.GOд1ת
#define ADC_TRIGGER_TIMR0		6
#define ADC_TRIGGER_TIMR1		7
#define ADC_TRIGGER_PWM0		0x5001
#define ADC_TRIGGER_PWM1		0x5004

#elif defined(CHIP_SWM211)

#define ADC_TRIGGER_SW			0	//ADC->START.GOд1ת
#define ADC_TRIGGER_TIMR0		2
#define ADC_TRIGGER_TIMR1		3
#define ADC_TRIGGER_PWM0		0x1001
#define ADC_TRIGGER_PWM1		0x1004

#endif


void ADC_Init(ADC_TypeDef * ADCx, ADC_InitStructure * initStruct);		//ADCģתʼ
uint32_t ADC_Calibrate(ADC_TypeDef * ADCx);
void ADC_Open(ADC_TypeDef * ADCx);							//ADCӲADCת
void ADC_Close(ADC_TypeDef * ADCx);							//ADCرգ޷ӲADCת
void ADC_Start(ADC_TypeDef * ADCx);							//ָADCʼģת
void ADC_Stop(ADC_TypeDef * ADCx);							//رָADCֹͣģת

uint32_t ADC_Read(ADC_TypeDef * ADCx, uint32_t chn);		//ָͨȡת
uint32_t ADC_IsEOC(ADC_TypeDef * ADCx, uint32_t chn);		//ָͨǷEnd Of Conversion

void ADC_ChnSelect(ADC_TypeDef * ADCx, uint32_t chns);

void ADC_IntEOCEn(ADC_TypeDef * ADCx, uint32_t chn);		//תжʹ
void ADC_IntEOCDis(ADC_TypeDef * ADCx, uint32_t chn);		//תжϽֹ
void ADC_IntEOCClr(ADC_TypeDef * ADCx, uint32_t chn);		//תжϱ־
uint32_t ADC_IntEOCStat(ADC_TypeDef * ADCx, uint32_t chn);	//תж״̬

void ADC_IntOVFEn(ADC_TypeDef * ADCx, uint32_t chn);		//жʹ
void ADC_IntOVFDis(ADC_TypeDef * ADCx, uint32_t chn);		//жϽֹ
void ADC_IntOVFClr(ADC_TypeDef * ADCx, uint32_t chn);		//жϱ־
uint32_t ADC_IntOVFStat(ADC_TypeDef * ADCx, uint32_t chn);	//ж״̬


#endif //__SWM2X1_ADC_H__
