#ifndef __SWM2X1_DMA_H__
#define __SWM2X1_DMA_H__


typedef struct {
	uint8_t  Mode;			//DMA_MODE_SINGLEDMA_MODE_CIRCLE
	
	uint8_t  Unit;			//DMA_UNIT_BYTEDMA_UNIT_HALFWORDDMA_UNIT_WORD
	
	uint32_t Count;			// Unit ȡֵ0x100000
	
	uint32_t SrcAddr;
	
	uint32_t DstAddr;
	
	uint8_t  SrcAddrInc;	//0 ̶ַ    1 ַ
	
	uint8_t  DstAddrInc;
	
	uint8_t  Handshake;		//źţDMA_HS_NODMA_CH0_UART0TXDMA_CH0_SPI0TX... ...
	
	uint8_t  Priority;		//DMA_PRI_LOWDMA_PRI_HIGH
		
	uint8_t  DoneIE;		//жʹ
} DMA_InitStructure;


#define DMA_CH0		0
#define DMA_CH1		1
#define DMA_CH2		2
#define DMA_CH3		3

#define DMA_MODE_SINGLE			0		// ģʽɺֹͣ
#define DMA_MODE_CIRCLE			1		// ģʽɺͷִһִ

#define DMA_UNIT_BYTE		0
#define DMA_UNIT_HALFWORD	1
#define DMA_UNIT_WORD		2

#define DMA_PRI_LOW			0
#define DMA_PRI_HIGH		1


#define DMA_HS_NO			(0 << 4)	// ֣Handshakeźţȫ
#define DMA_HS_SRC			(1 << 4)	// Դ  źţԴ  һݣDMAһUnit
#define DMA_HS_DST			(2 << 4)	// ĿźţĿȡһݣDMAһUnit
#define DMA_HS_EXT			(4 << 4)	// ⲿ  źţⲿһ壬DMAһUnit
#define DMA_HS_MSK			(7 << 4)

#define DMA_DIR_RX			(0 << 7)	// SRC --> DST
#define DMA_DIR_TX			(1 << 7)	// DST --> SRC
#define DMA_DIR_MSK			(1 << 7)

// Դ
#define DMA_CH0_UART0RX		(0 | DMA_HS_SRC | DMA_DIR_RX)
#define DMA_CH0_SPI0RX		(1 | DMA_HS_SRC | DMA_DIR_RX)
#define DMA_CH0_UART1RX		(2 | DMA_HS_SRC | DMA_DIR_RX)
#define DMA_CH0_SPI1RX		(3 | DMA_HS_SRC | DMA_DIR_RX)

#define DMA_CH1_UART0RX		(0 | DMA_HS_SRC | DMA_DIR_RX)
#define DMA_CH1_SPI0RX		(1 | DMA_HS_SRC | DMA_DIR_RX)
#define DMA_CH1_MPURX		(2 | DMA_HS_SRC | DMA_DIR_RX)
#define DMA_CH1_ADC0		(3 | DMA_HS_SRC | DMA_DIR_RX)

// Ŀ
#define DMA_CH0_UART0TX		(0 | DMA_HS_DST | DMA_DIR_RX)
#define DMA_CH0_SPI0TX		(1 | DMA_HS_DST | DMA_DIR_RX)
#define DMA_CH0_UART1TX		(2 | DMA_HS_DST | DMA_DIR_RX)
#define DMA_CH0_SPI1TX		(3 | DMA_HS_DST | DMA_DIR_RX)

#define DMA_CH1_UART0TX		(0 | DMA_HS_DST | DMA_DIR_RX)
#define DMA_CH1_SPI0TX		(1 | DMA_HS_DST | DMA_DIR_RX)
#define DMA_CH1_MPUTX		(2 | DMA_HS_DST | DMA_DIR_RX)

// ⲿź
#define DMA_EXHS_TIMR0		(0 | DMA_HS_EXT | DMA_DIR_RX)
#define DMA_EXHS_TIMR1		(1 | DMA_HS_EXT | DMA_DIR_RX)
#define DMA_EXHS_TIMR2		(2 | DMA_HS_EXT | DMA_DIR_RX)



void DMA_CH_Init(uint32_t chn, DMA_InitStructure * initStruct);	//DMAͨ
void DMA_CH_Open(uint32_t chn);
void DMA_CH_Close(uint32_t chn);

void DMA_CH_INTEn(uint32_t chn);				//DMAжʹܣݰɺ󴥷ж
void DMA_CH_INTDis(uint32_t chn);				//DMAжϽֹݰɺ󲻴ж
void DMA_CH_INTClr(uint32_t chn);				//DMAжϱ־
uint32_t DMA_CH_INTStat(uint32_t chn);			//DMAж״̬ѯ1 ݰ    0 ݰδ


#endif //__SWM2X1_DMA_H__
